@echo off
set ROOTPATH=%~1
set UPDATEPACKFILE=%~2
set EXENAME=%~3
:: Parameter validation
if "%ROOTPATH%"=="" (
    echo Error: ROOTPATH is not specified.
    exit /b 1
)

if not exist "%ROOTPATH%" (
    echo Error: ROOTPATH "%ROOTPATH%" does not exist.
    exit /b 1
)

if "%UPDATEPACKFILE%"=="" (
    echo Error: UPDATEPACKFILE is not specified.
    exit /b 1
)

if not exist "%UPDATEPACKFILE%" (
    echo Error: UPDATEPACKFILE "%UPDATEPACKFILE%" does not exist.
    exit /b 1
)

echo Updating...

:: 1. Clean up process (suppress error message and continue regardless of result)
timeout /t 1 > nul
tasklist /fi "imagename eq %EXENAME%" 2>&1 | find /i "%EXENAME%" > nul
if not errorlevel 1 (
    taskkill /f /T /im "%EXENAME%" > nul
    timeout /t 1 > nul
)

tasklist /fi "imagename eq %EXENAME%" 2>&1 | find /i "%EXENAME%" > nul
if not errorlevel 1 (
    echo The process is still running. Exiting.
    exit /b
)
:: 2. Determine update method
set FILENAME=%UPDATEPACKFILE%
for %%a in (%FILENAME%) do set EXT=%%~xa

if /i "%EXT%"==".zip" (
    echo Portable update...

    :: Create unzip_temp folder
    mkdir "%ROOTPATH%\unzip_temp"

    :: Copy unzip.exe to unzip_temp folder
    copy "%ROOTPATH%\unzip.exe" "%ROOTPATH%\unzip_temp" > nul

    :: Unzip update pack to unzip_temp
    "%ROOTPATH%\unzip_temp\unzip.exe" -o "%UPDATEPACKFILE%" -d "%ROOTPATH%\unzip_temp" > nul

    :: Move files from unzip_temp\PixPin to root path
    xcopy "%ROOTPATH%\unzip_temp\PixPin\*.*" "%ROOTPATH%" /E /Y /I > nul || (echo Failed to copy updated files and folders && exit /b 1)
    
    :: Clean up unzip_temp directory
    rmdir /s /q "%ROOTPATH%\unzip_temp"

    :: Run executable
    start "" "%ROOTPATH%\%EXENAME%"
) else (
    echo Installer update...

    :: Run installer silently
    start /wait "" "%UPDATEPACKFILE%" /CLOSEAPPLICATIONS /SILENT
)

echo Update complete.
